﻿#ifndef SYSCOMMUGROUPMGT_H
#define SYSCOMMUGROUPMGT_H

#include <tbaseutil/tdataresponse.h>
#include <tdatabaseutil/tsqlselectorv2.h>
#include <topcore/topclassabs.h>
#include <topcore/topclasshelper.h>

class TTableView;
class TSearchEntry;
class TPageTool;
class TSplitter;
class SysCommuGroup;

class SysCommuGroupMgt : public TopClassAbs
{
    Q_OBJECT
public:
    explicit SysCommuGroupMgt(const QString &iModuleNameStr = QString(""),
                        const QVariantMap &iUrlPars = QVariantMap(),
                        QWidget *iParent = nullptr);
    ~SysCommuGroupMgt();

public slots:
    void refresh(bool iResetPageBol = true);
    void deleteItem(const QVariantList &iIdLst);
    QVariantList selectedItems();
    TopClassAbs *openItem(int iIdInt);
    void newItem();
    void onClearNavi();
    void onNaviDataChanged();
    QVariantList plantList();
    QVariantList departmentList();
    QVariantMap departmentMap();

private slots:
    void onPageChanged();
    void onSelectionChanged();
    void onDetailSaved(const QVariant &iUidStr);
    void onDetailChanged();

private:
    TSqlSelectorV2 getSqlSelector(bool iResetPageBol = true);
    void initTableView();
    void initNaviView();
    void fillTableData(const TDataResponse &iDataRes);

private:
    TTableView *mTableView = nullptr;
    TSearchEntry *mSearchEntry= nullptr;
    TPageTool *mPageTool= nullptr;
    QVariantList mSelectedLst;
    SysCommuGroup *mDetailView= nullptr;
    TSplitter *mBodySplitter = nullptr;
    TSplitter* mBodyWidget = nullptr;
    TUiLoader *mNaviView = nullptr;
    QString mFixedSqlWhere;
    TopClassTableConf mTableConf;
};

#endif // SYSCOMMUGROUPMGT_H
